# Dex Enhancement Proposal

## Why do we need it?

Dex Enhancement Proposal (DEP) is a design document providing information to the community, or describing a new feature for Dex.

We intend DEPs to be the primary mechanisms for proposing major new features or significant changes to existing ones.
This will make it easier for the community to describe, track, and look through the history of changes that affected the development of the project.

## Process

### Before starting
1. Search GitHub for previous [issues](https://github.com/dexidp/dex/issues), [discussions](https://github.com/dexidp/dex/discussions) and [DEPs](https://github.com/dexidp/dex/tree/master/docs/enhancements).
2. If a discussion does not exist, [open it](https://github.com/dexidp/dex/discussions/new?category=Ideas).
3. Ensure that writing enhancement proposal is necessary for you change by discussing it with a community.

### Writing an enhancement proposal

1. Fork the repo.
2. Copy the [`docs/enhancements/_title-YYYY-MM-DD-#issue.md`](docs/enhancements/_title-YYYY-MM-DD-#issue.md) template with the appropriate
   name.
3. Fill all sections according to hints in them. Provide as much information as you can.
4. Submit your PR and discuss it with the Dex team.
