// Code generated by ent, DO NOT EDIT.

package authcode

import (
	"entgo.io/ent/dialect/sql"
)

const (
	// Label holds the string label denoting the authcode type in the database.
	Label = "auth_code"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldClientID holds the string denoting the client_id field in the database.
	FieldClientID = "client_id"
	// FieldScopes holds the string denoting the scopes field in the database.
	FieldScopes = "scopes"
	// FieldNonce holds the string denoting the nonce field in the database.
	FieldNonce = "nonce"
	// FieldRedirectURI holds the string denoting the redirect_uri field in the database.
	FieldRedirectURI = "redirect_uri"
	// FieldClaimsUserID holds the string denoting the claims_user_id field in the database.
	FieldClaimsUserID = "claims_user_id"
	// FieldClaimsUsername holds the string denoting the claims_username field in the database.
	FieldClaimsUsername = "claims_username"
	// FieldClaimsEmail holds the string denoting the claims_email field in the database.
	FieldClaimsEmail = "claims_email"
	// FieldClaimsEmailVerified holds the string denoting the claims_email_verified field in the database.
	FieldClaimsEmailVerified = "claims_email_verified"
	// FieldClaimsGroups holds the string denoting the claims_groups field in the database.
	FieldClaimsGroups = "claims_groups"
	// FieldClaimsPreferredUsername holds the string denoting the claims_preferred_username field in the database.
	FieldClaimsPreferredUsername = "claims_preferred_username"
	// FieldConnectorID holds the string denoting the connector_id field in the database.
	FieldConnectorID = "connector_id"
	// FieldConnectorData holds the string denoting the connector_data field in the database.
	FieldConnectorData = "connector_data"
	// FieldExpiry holds the string denoting the expiry field in the database.
	FieldExpiry = "expiry"
	// FieldCodeChallenge holds the string denoting the code_challenge field in the database.
	FieldCodeChallenge = "code_challenge"
	// FieldCodeChallengeMethod holds the string denoting the code_challenge_method field in the database.
	FieldCodeChallengeMethod = "code_challenge_method"
	// Table holds the table name of the authcode in the database.
	Table = "auth_codes"
)

// Columns holds all SQL columns for authcode fields.
var Columns = []string{
	FieldID,
	FieldClientID,
	FieldScopes,
	FieldNonce,
	FieldRedirectURI,
	FieldClaimsUserID,
	FieldClaimsUsername,
	FieldClaimsEmail,
	FieldClaimsEmailVerified,
	FieldClaimsGroups,
	FieldClaimsPreferredUsername,
	FieldConnectorID,
	FieldConnectorData,
	FieldExpiry,
	FieldCodeChallenge,
	FieldCodeChallengeMethod,
}

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	return false
}

var (
	// ClientIDValidator is a validator for the "client_id" field. It is called by the builders before save.
	ClientIDValidator func(string) error
	// NonceValidator is a validator for the "nonce" field. It is called by the builders before save.
	NonceValidator func(string) error
	// RedirectURIValidator is a validator for the "redirect_uri" field. It is called by the builders before save.
	RedirectURIValidator func(string) error
	// ClaimsUserIDValidator is a validator for the "claims_user_id" field. It is called by the builders before save.
	ClaimsUserIDValidator func(string) error
	// ClaimsUsernameValidator is a validator for the "claims_username" field. It is called by the builders before save.
	ClaimsUsernameValidator func(string) error
	// ClaimsEmailValidator is a validator for the "claims_email" field. It is called by the builders before save.
	ClaimsEmailValidator func(string) error
	// DefaultClaimsPreferredUsername holds the default value on creation for the "claims_preferred_username" field.
	DefaultClaimsPreferredUsername string
	// ConnectorIDValidator is a validator for the "connector_id" field. It is called by the builders before save.
	ConnectorIDValidator func(string) error
	// DefaultCodeChallenge holds the default value on creation for the "code_challenge" field.
	DefaultCodeChallenge string
	// DefaultCodeChallengeMethod holds the default value on creation for the "code_challenge_method" field.
	DefaultCodeChallengeMethod string
	// IDValidator is a validator for the "id" field. It is called by the builders before save.
	IDValidator func(string) error
)

// OrderOption defines the ordering options for the AuthCode queries.
type OrderOption func(*sql.Selector)

// ByID orders the results by the id field.
func ByID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldID, opts...).ToFunc()
}

// ByClientID orders the results by the client_id field.
func ByClientID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldClientID, opts...).ToFunc()
}

// ByNonce orders the results by the nonce field.
func ByNonce(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldNonce, opts...).ToFunc()
}

// ByRedirectURI orders the results by the redirect_uri field.
func ByRedirectURI(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldRedirectURI, opts...).ToFunc()
}

// ByClaimsUserID orders the results by the claims_user_id field.
func ByClaimsUserID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldClaimsUserID, opts...).ToFunc()
}

// ByClaimsUsername orders the results by the claims_username field.
func ByClaimsUsername(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldClaimsUsername, opts...).ToFunc()
}

// ByClaimsEmail orders the results by the claims_email field.
func ByClaimsEmail(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldClaimsEmail, opts...).ToFunc()
}

// ByClaimsEmailVerified orders the results by the claims_email_verified field.
func ByClaimsEmailVerified(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldClaimsEmailVerified, opts...).ToFunc()
}

// ByClaimsPreferredUsername orders the results by the claims_preferred_username field.
func ByClaimsPreferredUsername(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldClaimsPreferredUsername, opts...).ToFunc()
}

// ByConnectorID orders the results by the connector_id field.
func ByConnectorID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldConnectorID, opts...).ToFunc()
}

// ByExpiry orders the results by the expiry field.
func ByExpiry(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldExpiry, opts...).ToFunc()
}

// ByCodeChallenge orders the results by the code_challenge field.
func ByCodeChallenge(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldCodeChallenge, opts...).ToFunc()
}

// ByCodeChallengeMethod orders the results by the code_challenge_method field.
func ByCodeChallengeMethod(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldCodeChallengeMethod, opts...).ToFunc()
}
