// Code generated by ent, DO NOT EDIT.

package db

import (
	"context"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/dexidp/dex/storage/ent/db/devicetoken"
	"github.com/dexidp/dex/storage/ent/db/predicate"
)

// DeviceTokenDelete is the builder for deleting a DeviceToken entity.
type DeviceTokenDelete struct {
	config
	hooks    []Hook
	mutation *DeviceTokenMutation
}

// Where appends a list predicates to the DeviceTokenDelete builder.
func (dtd *DeviceTokenDelete) Where(ps ...predicate.DeviceToken) *DeviceTokenDelete {
	dtd.mutation.Where(ps...)
	return dtd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (dtd *DeviceTokenDelete) Exec(ctx context.Context) (int, error) {
	return withHooks(ctx, dtd.sqlExec, dtd.mutation, dtd.hooks)
}

// ExecX is like Exec, but panics if an error occurs.
func (dtd *DeviceTokenDelete) ExecX(ctx context.Context) int {
	n, err := dtd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (dtd *DeviceTokenDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := sqlgraph.NewDeleteSpec(devicetoken.Table, sqlgraph.NewFieldSpec(devicetoken.FieldID, field.TypeInt))
	if ps := dtd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	affected, err := sqlgraph.DeleteNodes(ctx, dtd.driver, _spec)
	if err != nil && sqlgraph.IsConstraintError(err) {
		err = &ConstraintError{msg: err.Error(), wrap: err}
	}
	dtd.mutation.done = true
	return affected, err
}

// DeviceTokenDeleteOne is the builder for deleting a single DeviceToken entity.
type DeviceTokenDeleteOne struct {
	dtd *DeviceTokenDelete
}

// Where appends a list predicates to the DeviceTokenDelete builder.
func (dtdo *DeviceTokenDeleteOne) Where(ps ...predicate.DeviceToken) *DeviceTokenDeleteOne {
	dtdo.dtd.mutation.Where(ps...)
	return dtdo
}

// Exec executes the deletion query.
func (dtdo *DeviceTokenDeleteOne) Exec(ctx context.Context) error {
	n, err := dtdo.dtd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{devicetoken.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (dtdo *DeviceTokenDeleteOne) ExecX(ctx context.Context) {
	if err := dtdo.Exec(ctx); err != nil {
		panic(err)
	}
}
